package com.gic.spark;

import com.gic.sharding.sdk.ShardingConfigManager;
import com.gic.spark.application.SparkEnvManager;
import com.gic.spark.config.SparkConfigManager;
import com.gic.spark.tag.TagProcessManager;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/4/15
 */
public class SparkTagProcess {

    public static void main(String[] args){
        if (args == null || args.length < 2) {
            System.err.println("invalidate input params:");
            System.err.println("1.is production: true/false");
            System.err.println("2.extract data: true/false");
            System.exit(2);
        }

        boolean isProd = Boolean.parseBoolean(args[0]);
        boolean extractData = Boolean.parseBoolean(args[1]);
        ShardingConfigManager.initDefualt();
        SparkEnvManager.getInstance().init("member_tag_4.0");
        SparkConfigManager.getInstance().init(SparkConfigManager.EnvType.PRO, null);
        TagProcessManager.getInstance().init(isProd);
        TagProcessManager.getInstance().process(extractData);
    }
}
