package com.gic.spark;

import com.gic.sharding.sdk.ShardingConfigManager;
import com.gic.spark.application.SparkEnvManager;
import com.gic.spark.config.SparkConfigManager;
import com.gic.spark.tag.TagProcessManager;

import java.util.ArrayList;
import java.util.List;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/4/15
 */
public class SparkTagProcessByTagGroupId {

    public static void main(String[] args){
        if (args == null || args.length < 4) {
            System.err.println("invalidate input params:");
            System.err.println("1.is production: true/false");
            System.err.println("2.extract data: true/false");
            System.err.println("3.id: tagGroupId");
            System.exit(2);
        }

        boolean isProd = Boolean.parseBoolean(args[0]);
        boolean extractData = Boolean.parseBoolean(args[1]);
        String[] arrs=args[2].split(",");
        List<Integer>params=new ArrayList();
        for(String s:arrs){
            params.add(Integer.parseInt(s));
        }
        ShardingConfigManager.initDefualt();
        SparkEnvManager.getInstance().init("member_tag_4.0");
        SparkConfigManager.getInstance().init(SparkConfigManager.EnvType.PRO, null);
        TagProcessManager.getInstance().init(isProd);
        TagProcessManager.getInstance().setTagGroupId(params);
        TagProcessManager.getInstance().process(extractData);
    }
}
