package com.gic.spark.datasource;

import com.gic.sharding.sdk.ShardingConfigManager;
import com.gic.spark.datasource.entity.DataSourceEntity;
import com.gic.spark.datasource.entity.DataSourceMysql;
import com.gic.spark.datasource.entity.DataSourceSharding;
import com.gic.spark.datasource.mysql.MysqlDatasource;
import com.gic.spark.util.DingtalkMessageUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/3/27
 */
public class DataSourceManager {

    private Map<String, List<Integer>> datasourceEnterpriseMap = new HashMap();

    private Map<String, DataSourceEntity> datasourceEntityMap = new HashMap();
    private boolean isProduction = false;

    private static DataSourceManager instance = null;

    public static DataSourceManager getInstance() {
        if (instance == null) {
            instance = new DataSourceManager();
        }
        return instance;
    }

    private DataSourceManager() {
    }

    public void init(boolean isProduction) {
        this.isProduction = isProduction;
    }


    public void addSourceEntity(DataSourceEntity sourceEntity, Integer enterpriseId) {
        /*if (!isProduction) {
            switch (sourceEntity.getSourceType()) {
                case MYSQL:
                    DataSourceMysql mysqlDataSource = (DataSourceMysql) sourceEntity;
                    if (mysqlDataSource.getDatasource() == MysqlDatasource.prodDatasource) {
                        mysqlDataSource.setDatasource(MysqlDatasource.devDatasource);
                    }
                    break;
                case MYSQL_SHARDING:
                    DataSourceSharding sourceSharding = (DataSourceSharding) sourceEntity;
                    if (sourceSharding.getShardingConfig().get_id().equals("member_sharding_readonly")) {
                        sourceSharding.setShardingConfig(ShardingConfigManager.getInstance().getCurrentShardingConfig("member_sharding_test"));
                    } else if (sourceSharding.getShardingConfig().get_id().equals("market_sharding")) {
                        sourceSharding.setShardingConfig(ShardingConfigManager.getInstance().getCurrentShardingConfig("market_sharding_test"));
                    } else {
                        DingtalkMessageUtil.sendAlertMessage("标签处理，分库分表数据源未配置开发环境：" + sourceSharding.getShardingConfig().get_id());
                    }


                    break;
                case MONGODB:

                    break;
            }
        }*/


        String key = sourceEntity.getSourceKey();

        if (!datasourceEnterpriseMap.containsKey(key)) {
            datasourceEnterpriseMap.put(key, new ArrayList());
        }

        if (!datasourceEntityMap.containsKey(key)) {
            datasourceEntityMap.put(key, sourceEntity);
        }

        List<Integer> enterpriseList = datasourceEnterpriseMap.get(key);
        if (!enterpriseList.contains(enterpriseId))
            enterpriseList.add(enterpriseId);


    }

    public void extractDataToDatabase() {
        for (Map.Entry<String, DataSourceEntity> entityEntry : datasourceEntityMap.entrySet()) {

            String key = entityEntry.getKey();
            DataSourceEntity sourceEntity = entityEntry.getValue();

            sourceEntity.extractDataToPartitionedHiveTable(datasourceEnterpriseMap.get(key));
        }
    }

}
