package com.gic.spark.datasource;

import com.gic.spark.application.SparkEnvManager;
import com.google.common.base.Joiner;
import com.google.common.collect.Maps;
import com.mongodb.spark.MongoSpark;
import com.mongodb.spark.config.ReadConfig;
import com.mongodb.spark.rdd.api.java.JavaMongoRDD;
import org.apache.spark.api.java.JavaSparkContext;
import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.Row;
import org.apache.spark.sql.SparkSession;
import org.bson.Document;

import java.util.HashMap;
import java.util.Map;

import static java.util.Collections.singletonList;

/**
 * Created by paste on 2018/7/30 10:03
 * <p>
 * TODO: class description
 */
public class MongodbRddManager {
    private static MongodbRddManager instance = null;


    private Map<String, String> baseReadMap = new HashMap();

    public static MongodbRddManager getInstance() {
        if (instance == null) {
            instance = new MongodbRddManager();
        }
        return instance;
    }

    private MongodbRddManager() {
        baseReadMap.put("partitionerOptions.partitionSizeMB", "64");
        baseReadMap.put("uri", "mongodb://mongouser:iP7LwQsezaWW@10.0.1.2:27017/gic-deploy.cluster_config?authSource=admin");
    }


    public JavaMongoRDD<Document> getDocument(String database, String collection) {
        SparkEnvManager.getInstance().addProperty("spark.mongodb.input.uri", "mongodb://10.0.1.2:27017/gic-deploy.cluster_config?readPreference=secondaryPreferred");
        SparkEnvManager.getInstance().addProperty("spark.mongodb.input.partitionerOptions.partitionSizeMB", "64");
        JavaSparkContext jsc=SparkEnvManager.getInstance().getJsc();

        Map<String, String> readOverrides = Maps.newHashMap(baseReadMap);
        readOverrides.put("database", database);
        readOverrides.put("collection", collection);

        ReadConfig readConfig = ReadConfig.create(jsc).withOptions(readOverrides);

        return MongoSpark.load(jsc, readConfig);
    }

    public JavaMongoRDD<Document> getDocumentsByColumn(String database, String collection, String columnName, String... values) {
        System.out.println("extracting database: " + database + " collection: " + collection);
        JavaMongoRDD<Document> document = getDocument(database, collection);

        return document.withPipeline(singletonList(Document.parse(String.format("{$match : { %s: {$in:['" + Joiner.on("','").join(values) + "']}}}", columnName))));
    }

    public Dataset<Row> getDataset(String database, String collection) {
        return getDocument(database, collection).toDF();
    }

}
