package com.gic.spark.datasource.entity;

import com.gic.spark.application.SparkEnvManager;
import com.gic.spark.tag.TagProcessManager;
import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.Row;

import java.util.List;

/**
 * Created by paste on 2018/7/27 16:36
 * <p>
 * TODO: class description
 */
public abstract class DataSourceEntity {

    protected DataSourceType sourceType;

    public DataSourceType getSourceType() {
        return sourceType;
    }

    public abstract String getSourceKey();

    public abstract String getHiveTableName();

    protected String getSchema(){
        return TagProcessManager.getInstance().isProduction()?"tag4_prod":"tag4_test";
    }

    public Dataset<Row> getDatasetByEnterpriseId(Integer enterpriseId) {
        return SparkEnvManager.getInstance().getSparkSession().sql(String.format("select * from %s where enterprise_id='%s'", getHiveTableName(), enterpriseId));
    }

    public Dataset<Row> getDatasetByEntId(Integer enterpriseId) {
        return SparkEnvManager.getInstance().getSparkSession().sql(String.format("select * from %s where ent_id='%s'", getHiveTableName(), enterpriseId));
    }

    public abstract void extractDataToPartitionedHiveTable(List<Integer> enterpriseList);

}
