package com.gic.spark.datasource.entity;

import com.gic.spark.application.SparkEnvManager;
import com.gic.spark.datasource.MongodbRddManager;
import com.gic.spark.util.HivePartitionUtil;
import com.gic.spark.util.SparkHiveUtil;
import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.Row;
import org.apache.spark.sql.SparkSession;

import java.util.List;

/**
 * Created by paste on 2018/7/27 16:59
 * <p>
 * TODO: class description
 */
public class DataSourceMongodb extends DataSourceEntity {
    private String database;
    private String collection;
    private String partitionColumn;

    public DataSourceMongodb(String database, String collection, String partitionColumn) {
        sourceType = DataSourceType.MONGODB;
        this.database = database;
        this.collection = collection;
        this.partitionColumn = partitionColumn;
    }

    public String getDatabase() {
        return database;
    }

    public void setDatabase(String database) {
        this.database = database;
    }

    @Override
    public String getSourceKey() {
        return sourceType.getName() + "_" + database + "_" + collection;
    }

    @Override
    public String getHiveTableName() {
        return getSchema()+"." + database + "_" + collection;
    }

    @Override
    public void extractDataToPartitionedHiveTable(List<Integer> enterpriseList) {
        SparkSession sparkSession = SparkEnvManager.getInstance().getSparkSession();
        boolean isTableCreated = SparkHiveUtil.isTableExist(getSchema(), database + "_" + collection, sparkSession);
        String[] enterpriseIds = new String[enterpriseList.size()];
        enterpriseList.toArray(enterpriseIds);
        Dataset<Row> dataset = MongodbRddManager.getInstance().getDocumentsByColumn(database, collection, partitionColumn, enterpriseIds).toDF();
        if (!isTableCreated) {
            SparkHiveUtil.createHivePartitionTable(dataset, partitionColumn, getSchema(), database + "_" + collection,sparkSession);
            isTableCreated = true;
        }
        HivePartitionUtil.saveDatasetToPartitionTable(sparkSession, dataset, getHiveTableName());
    }
}
