package com.gic.spark.datasource.entity;

import com.gic.spark.application.SparkEnvManager;
import com.gic.spark.datasource.mysql.MysqlDatasource;
import com.gic.spark.util.HivePartitionUtil;
import com.gic.spark.util.SparkHiveUtil;
import org.apache.spark.sql.Column;
import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.Row;
import org.apache.spark.sql.SparkSession;

import java.util.List;

/**
 * Created by paste on 2018/7/27 16:57
 * <p>
 * TODO: class description
 */
public class DataSourceMysql extends DataSourceEntity {

    private MysqlDatasource datasource;
    private String targetTable;

    public DataSourceMysql(MysqlDatasource datasource, String targetTable) {
        sourceType = DataSourceType.MYSQL;

        this.datasource = datasource;
        this.targetTable = targetTable;
    }

    public MysqlDatasource getDatasource() {
        return datasource;
    }

    public void setDatasource(MysqlDatasource datasource) {
        this.datasource = datasource;
    }

    @Override
    public String getSourceKey() {
        return sourceType.getName() + "_" + datasource.getSchema() + "_" + targetTable;
    }

    @Override
    public String getHiveTableName() {
        return getSchema()+"." + datasource.getSchema().replaceAll("\\.", "_") + "_" + targetTable;
    }

    @Override
    public void extractDataToPartitionedHiveTable(List<Integer> enterpriseList) {
        SparkSession sparkSession = SparkEnvManager.getInstance().getSparkSession();
        Dataset<Row> sourceDataset = datasource.buildRddManager().getDatasetByEnterpriseIds(targetTable, enterpriseList, null, null).repartition(new Column("enterprise_id"));

        SparkHiveUtil.createHivePartitionTable(sourceDataset, "enterprise_id", getSchema(), datasource.getSchema().replaceAll("\\.", "_") + "_" + targetTable,sparkSession);

        HivePartitionUtil.saveDatasetToPartitionTable(sparkSession, sourceDataset, getHiveTableName());

    }
}
