package com.gic.spark.entity.enumtype;

import java.util.ArrayList;
import java.util.List;

/**
 * @author jiaotianqi
 * @ClassName:
 * @Description:
 * @date 2019年11月22日 14:41
 */
public enum TagValKeyEnum {

    ACU_AREA_INFO("acuInfo","小程序域",1),
    SCU_AREA_INFO("scuInfo","服务号",1),
    MCU_AREA_INFO("mcuInfo","会员卡域",1),

    ACU_AREA_BRAND("flag.acuInfo.*.brand","小程序域下品牌",3),
    SCU_AREA_BRAND("flag.acuInfo.*.brand","服务号域下品牌",3),
    MCU_AREA_BRAND("flag.acuInfo.*.brand","会员卡域下品牌",3),

    COMMODITY_BRAND("flag.brand","商品品牌",1),
    MCU_CARD("flag.mcuInfo","会员卡",1),
    WM_CHANNEL_STORE("flag.store.wx","微盟店铺",1),
    XX_ORDER_CHANNEL("flag.store.xx","线下渠道门店",1),
    WSC_ORDER_CHANNEL("flag.store.wsc","微商城店铺",1),

    TIME_RANGE("timeRange.fixation","时间范围-固定时段",2),
    TIME_RANGE_LATELY("timeRange.lately","时间范围-最近",2),
    TIME_RANGE_LATER("timeRange.later","时间范围-之后",2),

    CALENDAR_YMD("yearModDay.fixation","年月日固定",5),

    CALENDAR_YMD_DAY_TODAY("yearModDay.relative.day.today","年月日-相对-精度日-当前",5),
    CALENDAR_YMD_DAY_LATER("yearModDay.relative.day.later","年月日-相对-精度日-之后",5),
    CALENDAR_YMD_DAY_LATELY("yearModDay.relative.day.lately","年月日-相对-精度日-最近",5),
    CALENDAR_YMD_MOD_TODAY("yearModDay.relative.mod.today","年月日-相对-精度月-当前",5),
    CALENDAR_YMD_MOD_LATER("yearModDay.relative.mod.later","年月日-相对-精度月-之后",5),
    CALENDAR_YMD_MOD_LATELY("yearModDay.relative.mod.lately","年月日-相对-精度月-最近",5),
    CALENDAR_YMD_YEAR_TODAY("yearModDay.relative.year.today","年月日-相对-精度年-当前",5),
    CALENDAR_YMD_YEAR_LATER("yearModDay.relative.year.later","年月日-相对-精度年-之后",5),
    CALENDAR_YMD_YEAR_LATELY("yearModDay.relative.year.lately","年月日-相对-精度年-最近",5),


    CALENDAR_MD("modDay.fixation","月日固定",5),
    CALENDAR_MD_DAY_TODAY("modDay.relative.day.today","月日-相对-精度日-当前",5),
    CALENDAR_MD_DAY_LATER("modDay.relative.day.later","月日-相对-精度日-之后",5),
    CALENDAR_MD_DAY_LATELY("modDay.relative.day.lately","月日-相对-精度日-最近",5),
    CALENDAR_MD_MOD_TODAY("modDay.relative.mod.today","月日-相对-精度月-当前",5),
    CALENDAR_MD_MOD_LATER("modDay.relative.mod.later","月日-相对-精度月-之后",5),
    CALENDAR_MD_MOD_LATELY("modDay.relative.mod.lately","月日-相对-精度月-最近",5),

    NUMBER_GT("number.gt","数字-大于",6),
    NUMBER_GTE("number.gte","数字-大于等于",6),
    NUMBER_LT("number.lt","数字-小于",6),
    NUMBER_LTE("number.lte","数字-小于等于",6),
    NUMBER_EQ("number.eq","数字-等于",6),
    NUMBER_BETWEEN("number.between","数字-范围",6),

    //需要根据业务定义多个
    COMPONENT_MULTIPLE("component.city","组件多选项-省市组件",8),
    COMPONENT_STORE("component.store","组件多选项-门店组件",8),
    COMPONENT_COMMODITY("component.commodity","组件多选项-商品组件",8),
    COMPONENT_COUPON("component.coupon","组件多选项-卡券组件",8),
    COMPONENT_CLERK("component.clerk","组件多选项-导购选择器",8),
    KEYWORD("keyword","类型-关键字输入",7),

    //需要根据业务定义多个
    CHECK_ITEM_YES_NO("yesNo","是否勾选项",4),
    CHECK_ITEM_Sex("sex","性别勾选项",4),
    CHECK_ITEM_EDUCATION("education","文化程度勾选项",4),
    CHECK_ITEM_MARRIAGE("marriage","婚姻勾选项",4),
    CHECK_ITEM_CHILDREN_INFO("childrenInfo","子女信息勾选项",4),
    CHECK_ITEM_INCOME("yearIncome","年收入勾选项",4),
    CHECK_ITEM_SHOP_PERIOD("shopPeriod","购物周期勾选项",4),
    CHECK_ITEM_PREFERENCE("preference","礼品偏好勾选项",4),
    CHECK_ITEM_AUTH_STATUS("authStatus","认证状态勾选项",4),
    CHECK_ITEM_OPEN_CARD_WAY("openCardWay","开卡方式勾选项",4),
    CHECK_ITEM_OPEN_CARD_CHANNEL("openCardChannel","开卡渠道勾选项",4),
    CHECK_ITEM_OPEN_CARD_STATUS("openCardStatus","开卡状态勾选项",4),
    CHECK_ITEM_FREEZE_STATUS("freezeStatus","冻结状态勾选项",4),
    CHECK_ITEM_ATTENTION_SOURCE("attentionSource","关注来源勾选项",4),
    CHECK_ITEM_FREEZE_CAUSE("freezeCause","冻结原因勾选项",4),
    CHECK_ITEM_ATTENTION_STATUS("attentionStatus","关注状态勾选项",4),
    CHECK_ITEM_visit_SOURCE("visitSource","访问来源勾选项",4),
    ;



    TagValKeyEnum(String key, String desc,Integer templateType) {
        this.key = key;
        this.desc = desc;
        this.templateType=templateType;
    }

    private String key;
    private String desc;
    private Integer templateType;

    public Integer getTemplateType() {
        return templateType;
    }

    public void setTemplateType(Integer templateType) {
        this.templateType = templateType;
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }

    public static List<TagValKeyEnum> queryByTemplateType(Integer templateType){
        List<TagValKeyEnum> res=new ArrayList();
        for (TagValKeyEnum value : values()) {
            if(value.getTemplateType().equals(templateType)){
                res.add(value);
            }
        }
        return res;
    }
    public static TagValKeyEnum getByTemplateTypeAndKey(String key,Integer templateType){
        for (TagValKeyEnum value : values()) {
            if(value.getTemplateType().equals(templateType)&& value.getKey().equals(key)){
                return value;
            }
        }
        return null;
    }

}