package com.gic.spark.filter;

import com.gic.spark.datasource.entity.DataSourceHive;
import com.gic.spark.entity.bean.TrdEcuSalesLabelBean;
import com.gic.spark.entity.request.TagConsumeRequest;
import com.gic.spark.util.ConstantUtil;
import org.apache.spark.api.java.JavaRDD;

import java.util.ArrayList;
import java.util.List;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/5/7
 */
public abstract class AbstractTagConsumFilter implements BaseTagFilter {
    DataSourceHive dataSourceHive = new DataSourceHive(ConstantUtil.ADS_GIC_TRD_ECU_SALES_LABEL_D);

    protected static JavaRDD<TrdEcuSalesLabelBean> statisticsTypeHandle(JavaRDD<TrdEcuSalesLabelBean> consumeRDD, TagConsumeRequest consumeRequest){
        consumeRDD=consumeRDD.mapPartitions(data->{
                                    List<TrdEcuSalesLabelBean> result=new ArrayList();
                                    while (data.hasNext()){
                                        TrdEcuSalesLabelBean consumeBean=data.next();
                                        switch (consumeRequest.getStatisticsType()){
                                            case COMMODITYBRAND:
                                                if(consumeRequest.getStatisticsValList().contains(consumeBean.getEnt_id())){
                                                    result.add(consumeBean);
                                                }
                                                break;
                                            case CHANNEL:
                                                if(consumeRequest.getStatisticsValList().contains(consumeBean.getEnt_id())){
                                                    result.add(consumeBean);
                                                }
                                                break;
                                            case MCUINFO:
                                                if(consumeRequest.getStatisticsValList().contains(consumeBean.getEnt_id())){
                                                    result.add(consumeBean);
                                                }
                                                break;
                                            default:break;
                                        }
                                    }
                                    return result.iterator();
                                });
        return consumeRDD;
    }
}
