package com.gic.spark.filter;

import com.gic.spark.datasource.entity.DataSourceHive;
import com.gic.spark.entity.bean.TrdVirtualOrderBean;
import com.gic.spark.entity.request.AbstractFilterRequest;
import com.gic.spark.entity.request.AbstractFilterRequestTime;
import com.gic.spark.util.ConstantUtil;
import com.gic.spark.util.DateUtil;
import org.apache.spark.api.java.JavaRDD;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;


/**
 * @description:
 * 消费记录
 * @author: wangxk
 * @date: 2020/8/3
 */
public abstract class AbstractTagConsumRecordFilter implements BaseTagFilter {

     DataSourceHive dataSourceHive = new DataSourceHive(ConstantUtil.DWD_GIC_TRD_VIRTUAL_WDORDER_D);

    protected static JavaRDD<TrdVirtualOrderBean> statisticsTypeHandle(JavaRDD<TrdVirtualOrderBean> consumeRecordRDD, AbstractFilterRequest request){
        consumeRecordRDD=consumeRecordRDD.mapPartitions(data->{
            List<TrdVirtualOrderBean> result=new ArrayList();
            while (data.hasNext()){
                TrdVirtualOrderBean consumeRecordBean=data.next();
                switch (request.getStatisticsType()){
                    case COMMODITYBRAND:
                        if(request.getStatisticsValList().contains(consumeRecordBean.getEnt_id())){
                            result.add(consumeRecordBean);
                        }
                        break;
                    case CHANNEL:
                        if(request.getStatisticsValList().contains(consumeRecordBean.getOrder_channel_code())){
                            result.add(consumeRecordBean);
                        }
                        break;
                    case MCUINFO:
                        if(request.getStatisticsValList().contains(consumeRecordBean.getArea_id())){
                            result.add(consumeRecordBean);
                        }
                        break;
                    default:break;
                }
            }
            return result.iterator();
        });
        return consumeRecordRDD;
    }

    protected static boolean checkTime(AbstractFilterRequestTime request,long consumeTime){
        Boolean result=false;
        switch (request.getTimeRangeType()){
            case FIXATION:
                if(consumeTime>=request.getBeginTime().getTime()
                        &&consumeTime<=request.getEndTime().getTime())
                    result=true;
                break;
            case LATELY:
                switch (request.getYearMonthDayType()){
                    case DAY:
                        if(consumeTime> DateUtil.addNumForDay(new Date(),request.getTimeNum()).getTime()){
                            result=true;
                        }
                        break;
                    case MONTH:
                        if(consumeTime>DateUtil.addNumForMonth(new Date(),request.getTimeNum()).getTime()){
                            result=true;
                        }
                        break;
                    case YEAR:
                        if(consumeTime>DateUtil.addNumForYear(new Date(),request.getTimeNum()).getTime()){
                            result=true;
                        }
                        break;
                    default:break;
                }
                break;
            default:break;
        }
        return  result;
    }
}
