package com.gic.spark.filter;

import com.gic.spark.datasource.entity.DataSourceEntity;
import com.gic.spark.datasource.mysql.MysqlRddManager;
import com.gic.spark.entity.bean.TrdVirtualOrderBean;
import com.gic.spark.entity.request.AbstractFilterRequest;
import com.gic.spark.entity.request.TagConsumeAmountRequest;
import com.gic.spark.util.CommonUtil;
import com.gic.spark.util.DateUtil;
import org.apache.spark.api.java.JavaRDD;
import scala.Tuple2;

import java.util.*;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/8/6
 */
public class TagFirstConsumptionMoneyFilter extends AbstractTagConsumRecordFilter {

    private static TagFirstConsumptionMoneyFilter instance;

    public static TagFirstConsumptionMoneyFilter getInstance() {
        if(null==instance){
            instance=new TagFirstConsumptionMoneyFilter();
        }
        return instance;
    }

    private TagFirstConsumptionMoneyFilter(){}
    @Override
    public List<DataSourceEntity> necessarySourceList() {
        List<DataSourceEntity> result = new ArrayList();
        result.add(dataSourceHive);
        return result;
    }

    @Override
    public JavaRDD<Long> filterValidMember(Integer enterpriseId, AbstractFilterRequest request) {
        TagConsumeAmountRequest consumeAmountRequest=(TagConsumeAmountRequest)request;
        JavaRDD<TrdVirtualOrderBean>consumeRecordRDD= MysqlRddManager.getPojoFromDataset(dataSourceHive.getDatasetByEntId(enterpriseId), TrdVirtualOrderBean.class).javaRDD();
        consumeRecordRDD=statisticsTypeHandle(consumeRecordRDD,consumeAmountRequest);
        int configStatus= CommonUtil.getConfigStatus(enterpriseId);

        JavaRDD<Long>ecuRdd=consumeRecordRDD.mapToPair(data-> Tuple2.apply(data.getEcu_id(),data))
                                .groupByKey()
                                .mapPartitions(data->{
                                    List<Long>result=new ArrayList();
                                    while (data.hasNext()){

                                        Tuple2<Long, Iterable<TrdVirtualOrderBean>> tp2=data.next();
                                        double firstConsumAmount=0;
                                        TrdVirtualOrderBean firstConsumeAmountBean=null;
                                        Map<String,TrdVirtualOrderBean>effectiveOrderMap=new HashMap();
                                        List<TrdVirtualOrderBean>noEffectiveOrderList=new ArrayList();
                                        tp2._2().forEach(element->{
                                            if(element.getPay_amt()>0){
                                                effectiveOrderMap.put(element.getOorder_no(),element);
                                            }else{
                                                noEffectiveOrderList.add(element);
                                            }
                                        });
                                        noEffectiveOrderList.forEach(noEffectiveOrder->{
                                            TrdVirtualOrderBean effectiveOrder=effectiveOrderMap.get(noEffectiveOrder.getOorder_no());
                                            if(noEffectiveOrder.getReceipts_time().substring(0,10).equals(effectiveOrder.getReceipts_time().substring(0,10))){
                                                effectiveOrder.setPaid_amt(effectiveOrder.getPaid_amt()+noEffectiveOrder.getPaid_amt());
                                                effectiveOrder.setPay_amt(effectiveOrder.getPay_amt()+noEffectiveOrder.getPay_amt());
                                            }
                                        });
                                        for(TrdVirtualOrderBean amountBean:effectiveOrderMap.values()){
                                            if(null==firstConsumeAmountBean){
                                                firstConsumeAmountBean=amountBean;
                                            }else{
                                                if(DateUtil.stringToDate(amountBean.getReceipts_time()).getTime()
                                                    <DateUtil.stringToDate(firstConsumeAmountBean.getReceipts_time()).getTime()){
                                                    firstConsumeAmountBean=amountBean;
                                                }
                                            }
                                        }
                                        firstConsumAmount=null!=firstConsumeAmountBean?
                                                        (configStatus==1?firstConsumeAmountBean.getPaid_amt():firstConsumeAmountBean.getPay_amt())
                                                        :firstConsumAmount;

                                        switch (consumeAmountRequest.getNumberType()){
                                            case between:
                                                if(firstConsumAmount>=consumeAmountRequest.getBeginNum()
                                                        &&firstConsumAmount<=consumeAmountRequest.getEndNum()){
                                                    result.add(tp2._1());
                                                }
                                                break;
                                            case lt:
                                                if(firstConsumAmount<consumeAmountRequest.getEndNum()){
                                                    result.add(tp2._1());
                                                }
                                                break;
                                            case gt:
                                                if(firstConsumAmount>consumeAmountRequest.getBeginNum()){
                                                    result.add(tp2._1());
                                                }
                                                break;
                                            case eq:
                                                if(firstConsumAmount==consumeAmountRequest.getEqualNum()){
                                                    result.add(tp2._1());
                                                }
                                                break;
                                            case lte:
                                                if(firstConsumAmount<=consumeAmountRequest.getEndNum()){
                                                    result.add(tp2._1());
                                                }
                                                break;
                                            case gte:
                                                if(firstConsumAmount>=consumeAmountRequest.getBeginNum()){
                                                    result.add(tp2._1());
                                                }
                                                break;
                                            default:break;
                                        }
                                    }
                                    return result.iterator();
                                });
        return ecuRdd;
    }
}
