package com.gic.spark.filter;

import com.gic.spark.datasource.entity.DataSourceEntity;
import com.gic.spark.datasource.mysql.MysqlRddManager;
import com.gic.spark.entity.bean.TrdVirtualOrderBean;
import com.gic.spark.entity.request.AbstractFilterRequest;
import com.gic.spark.entity.request.TagConsumeStoreRequest;
import org.apache.commons.lang.StringUtils;
import org.apache.spark.api.java.JavaRDD;
import scala.Tuple2;

import java.util.ArrayList;
import java.util.List;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/8/11
 */
public class TagHistoryOnlineConsumptionStoreFilter extends AbstractTagConsumRecordFilter{

    private static TagHistoryOnlineConsumptionStoreFilter instance;

    public static TagHistoryOnlineConsumptionStoreFilter getInstance() {
        if(null==instance){
            instance=new TagHistoryOnlineConsumptionStoreFilter();
        }
        return instance;
    }

    private TagHistoryOnlineConsumptionStoreFilter(){}

    @Override
    public List<DataSourceEntity> necessarySourceList() {
        List<DataSourceEntity> result = new ArrayList();
        result.add(dataSourceHive);
        return result;
    }

    @Override
    public JavaRDD<Long> filterValidMember(Integer enterpriseId, AbstractFilterRequest request) {
        TagConsumeStoreRequest storeRequest=(TagConsumeStoreRequest)request;
        JavaRDD<TrdVirtualOrderBean>consumeRecordRDD= MysqlRddManager.getPojoFromDataset(dataSourceHive.getDatasetByEntId(enterpriseId),TrdVirtualOrderBean.class).javaRDD();

        consumeRecordRDD=statisticsTypeHandle(consumeRecordRDD,storeRequest);
        JavaRDD<Long>ecuRdd=consumeRecordRDD.filter(data->data.getOrder_channel_code()!=1
                                                && null!=data.getShop_id())
                                                .mapToPair(data-> Tuple2.apply(data.getEcu_id(),data.getShop_id()))
                                                .filter(data->storeRequest.getStoreList().contains(data._2()))
                                                .reduceByKey((x,y)->x)
                                                .map(data->data._1());
        return ecuRdd;
    }
}
