package com.gic.spark.filter;

import com.gic.spark.datasource.entity.DataSourceEntity;
import com.gic.spark.datasource.mysql.MysqlRddManager;
import com.gic.spark.entity.bean.TrdVirtualOrderBean;
import com.gic.spark.entity.request.AbstractFilterRequest;
import com.gic.spark.entity.request.TagConsumeStoreRequest;
import com.gic.spark.util.DateUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.spark.api.java.JavaRDD;
import scala.Tuple2;

import java.util.ArrayList;
import java.util.List;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/8/11
 */
public class TagLatelyOnlineConsumptionStoreFilter extends AbstractTagConsumRecordFilter{

    private static TagLatelyOnlineConsumptionStoreFilter instance;

    public static TagLatelyOnlineConsumptionStoreFilter getInstance() {
        if(null==instance){
            instance=new TagLatelyOnlineConsumptionStoreFilter();
        }
        return instance;
    }

    private TagLatelyOnlineConsumptionStoreFilter(){}

    @Override
    public List<DataSourceEntity> necessarySourceList() {
        List<DataSourceEntity> result = new ArrayList();
        result.add(dataSourceHive);
        return result;
    }

    @Override
    public JavaRDD<Long> filterValidMember(Integer enterpriseId, AbstractFilterRequest request) {
        TagConsumeStoreRequest storeRequest=(TagConsumeStoreRequest)request;
        JavaRDD<TrdVirtualOrderBean>consumeRecordRDD= MysqlRddManager.getPojoFromDataset(dataSourceHive.getDatasetByEntId(enterpriseId),TrdVirtualOrderBean.class).javaRDD();

        consumeRecordRDD=statisticsTypeHandle(consumeRecordRDD,storeRequest);
        JavaRDD<Long>ecuRdd=consumeRecordRDD.filter(data->data.getOrder_channel_code()!=1
                                                && StringUtils.isNotEmpty(data.getReceipts_time())
                                                && null!=data.getShop_id())
                                                .mapToPair(data-> Tuple2.apply(data.getEcu_id(),Tuple2.apply(data.getReceipts_time(),data.getShop_id())))
                                                .reduceByKey((x,y)->{
                                                    if(DateUtil.strToDate(x._1(),DateUtil.FORMAT_DATETIME_19).getTime()
                                                            >DateUtil.strToDate(y._1(),DateUtil.FORMAT_DATETIME_19).getTime()){
                                                        return x;
                                                    }else{
                                                        return y;
                                                    }
                                                }).filter(data->storeRequest.getStoreList().contains(data._2()._2()))
                                                .map(data->data._1());
        return ecuRdd;
    }
}
