package com.gic.spark.util;

import com.alibaba.druid.pool.DruidDataSource;

import java.lang.reflect.Field;
import java.sql.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * @description:
 * @author: wangxk
 * @date: 2018/7/27
 */
public class DaoHelper {

    public static PreparedStatement getPreparedStatement(Connection connection,String sql) throws SQLException {
        return connection.prepareStatement(sql);
    }

    public static List query(Connection connection , String sql, Class clazz , Object... args){
        List result = new ArrayList();
        PreparedStatement statement=null;
        try {
            statement=getPreparedStatement(connection,sql);
            if(null!=args){
                for(int i=0;i<args.length;i++){
                    statement.setObject(i+1,args[i]);
                }
            }

            ResultSet resultSet=statement.executeQuery();
            ResultSetMetaData resultSetMetaData = resultSet.getMetaData();
            //业务对象的属性数组
            Field[] fields = clazz.getDeclaredFields();
            while (resultSet.next()) {
                Object obj = clazz.newInstance();//构造业务对象实体
                int colLen=resultSetMetaData.getColumnCount();
                for (int i = 1; i <=colLen ; i++) {
                    String columnLable = resultSetMetaData.getColumnLabel(i );
                    Object columnValue = resultSet.getObject(i);

                    for(int j=0;j<fields.length;j++){
                        Field f=fields[j];

                        if(f.getName().equalsIgnoreCase(columnLable)){//忽略大小写
                            boolean flag = f.isAccessible();
                            f.setAccessible(true);
                            f.set(obj, columnValue);
                            f.setAccessible(flag);
                        }
                    }
                }
                result.add(obj);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (InstantiationException e) {
            e.printStackTrace();
        } finally {
            if(null!=statement){
                try {
                    statement.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
            if(null!=connection){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }
        return result;
    }

    public static List<Map<String, Object>> select(Connection connection ,String sql, Object... args){
        List<Map<String, Object>> result = new ArrayList();
        PreparedStatement statement=null;
            try {
                statement=getPreparedStatement(connection,sql);
                if(null!=args){
                    for(int i=0;i<args.length;i++){
                        statement.setObject(i+1,args[i]);
                    }
                }

                ResultSet resultSet=statement.executeQuery();
                ResultSetMetaData resultSetMetaData = resultSet.getMetaData();
                while (resultSet.next()) {
                    Map<String, Object> values = new HashMap<String, Object>();
                    int colLen=resultSetMetaData.getColumnCount();
                    for (int i = 0; i <colLen ; i++) {
                        String columnLable = resultSetMetaData.getColumnLabel(i + 1);
                        Object columnValue = resultSet.getObject(i + 1);
                        values.put(columnLable, columnValue);
                    }
                    result.add(values);
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }finally {
                if(null!=statement){
                    try {
                        statement.close();
                    } catch (SQLException e) {
                        e.printStackTrace();
                    }
                }
                if(null!=connection){
                    try {
                        connection.close();
                    } catch (SQLException e) {
                        e.printStackTrace();
                    }
                }
            }
        return result;
    }

    public static void closePreparedStatement(PreparedStatement preparedStatement){
        if(null!=preparedStatement){
            try {
                preparedStatement.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    public static void closeConnection(Connection connection){
        if(null!=connection){
            try {
                connection.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    public static void main(String args[]) throws SQLException {
//        MysqlDatasource md=new MysqlDatasource();
//        List<Map<String, Object>> rsList= DaoHelper.query(md.getConnection(),"select count(1) count from tab_gic_erp_interface_control " +
//                "where enterprise_id=? and method_name='addMemberId'  and enable_status=0 and open_status=0",new Object[]{"ff808081675af0d801675df0514701ea"});
//        System.out.println(rsList.size());

        DruidDataSource dataSource = new DruidDataSource();
        dataSource.setUrl("jdbc:mysql://56cbb9f62fac6.sh.cdb.myqcloud.com:6634/enterprise_extract_byenterpriseid?useUnicode=true&characterEncoding=utf-8&zeroDateTimeBehavior=convertToNull&autoReconnect=true&rewriteBatchedStatements=true");
        dataSource.setUsername("cdb_outerroot");
        dataSource.setPassword("@09ui%sbc09");

//        String sql=String.format("select *  from tab_enterprisebyid_data_sync");
//        System.out.println("query:sql==>"+sql);
//        List<ColumnInfo> result=DaoHelper.query(dataSource.getConnection(),sql,new String[]{});
//        System.out.println(JSONObject.toJSONString(result));

    }
}
