package com.gic.spark.util;

import org.apache.log4j.Logger;

import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.regex.Pattern;

public class DateUtil {
    private static Logger log = Logger.getLogger(DateUtil.class.getName());
    public final static String FORMAT_DATA_SLASH_8 = "yyyy/M/d";
    public final static String FORMAT_DATA_SLASH_9_1 = "yyyy/M/dd";
    public final static String FORMAT_DATA_SLASH_9_2 = "yyyy/MM/d";
    public final static String FORMAT_DATA_SLASH_10 = "yyyy/MM/dd";

    public final static String FORMAT_DATE_4 = "yyyy";
    public final static String FORMAT_DATE_7 = "yyyy-MM";
    public final static String FORMAT_DATE_8 = "yyyyMMdd";
    public final static String FORMAT_DATE_10 = "yyyy-MM-dd";
    public final static String FORMAT_DATETIME_19 = "yyyy-MM-dd HH:mm:ss";
    public final static String FORMAT_DATETIME_18 = "yyyyMMddHHmmssSSSS";
    public final static String FORMAT_DATETIME_14 = "yyyyMMddHHmmss";
    public final static String FORMAT_DATETIME_16 = "yyyy-MM-dd HH:mm";
    public final static String FORMAT_DATETIME_24 = "yyyy-MM-dd HH:mm:ss:SSSS";
    public final static String FORMAT_TIME = "HH:mm:ss";
    public final static String FORMAT_MINUTE_TIME = "HH:mm";
    public final static String YEAR_MONTH = "yyyy-MM";
    public final static String MONTH_DAY = "MM-dd";
    public final static long ONE_MINUTE = 60000;     //一分钟的毫米数
    public final static long ONE_HOUR = 3600000;     //一小时的毫秒数
    public final static long ONE_DAY = 86400000;     //一天的毫秒数

//    private static String getSlashFormatString(String str) {
//        String formatDateTmp = "";
//        if (!StringUtil.isNotNullStr(str, true)) {
//            return formatDateTmp;
//        }
//
//        int strLength = str.length();
//        if (strLength == 8) {
//            return FORMAT_DATA_SLASH_8;
//        } else if (strLength == 9) {
//            int lastSlashIndex = str.lastIndexOf("/");
//            if (lastSlashIndex == 7) {
//
//            } else {
//
//            }
//        }
//        return formatDateTmp;
//    }

    private static String getFormatString(String str) {

        String formatDateTmp = "";
        if (!StringUtil.isNotNullStr(str, true)) {
            return formatDateTmp;
        }
        int strLength = str.length();
        if (strLength == 4){
            formatDateTmp = FORMAT_DATE_4;
        }else if (strLength == 7) {
            formatDateTmp = FORMAT_DATE_7;
        } else if (strLength == 8) {
            formatDateTmp = FORMAT_DATE_8;
        } else if (strLength == 10) {
            formatDateTmp = FORMAT_DATE_10;
        } else if (strLength == 18 && str.indexOf("-") < 0
                && str.indexOf(":") < 0) {
            formatDateTmp = FORMAT_DATETIME_18;
        } else if (strLength == 14 && str.indexOf("-") < 0
                && str.indexOf(":") < 0) {
            formatDateTmp = FORMAT_DATETIME_14;
        } else if (strLength == 16 && str.indexOf("-") < 0
                && str.indexOf(":") < 0) {
            formatDateTmp = FORMAT_DATETIME_16;
        } else if (str.indexOf("-") >= 0 && str.indexOf(":") >= 0) {// strLength>=17&&

            formatDateTmp = FORMAT_DATETIME_19;
        }
        return formatDateTmp;
    }

    public static String datetimeToString24(Date source) {
        if (source == null) {
            return null;
        }
        String tmpString = null;
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(
                FORMAT_DATETIME_24);
        try {
            tmpString = simpleDateFormat.format(source);
        } catch (Exception e) {
        }
        return tmpString;
    }

    private static String getTimeFormatString(String str) {
        String formatDateTmp = "";
        if (!StringUtil.isNotNullStr(str, true)) {
            return formatDateTmp;
        }

        int strLength = str.length();
        if (strLength == 19) {
            formatDateTmp = FORMAT_DATETIME_19;
        }
        if (strLength == 8) {
            formatDateTmp = FORMAT_TIME;
        } else if (strLength == 5) {
            formatDateTmp = FORMAT_MINUTE_TIME;
        }

        return formatDateTmp;
    }

    public static Date stringToDate(String str) {
        Date date = null;
        String formatDateTmp = "";
        try {
            if (!StringUtil.isNotNullStr(str, true)) {
                return date;
            }
            if (str.contains("/")) {
                formatDateTmp = FORMAT_DATA_SLASH_10;
            } else {
                formatDateTmp = getFormatString(str);
            }
            if (!StringUtil.isNotNullStr(formatDateTmp, true)) {
                return date;
            }
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat(
                    formatDateTmp);
            date = simpleDateFormat.parse(str);
        } catch (Exception e) {
            log.error("时间：String: " + str + " to Date: " + formatDateTmp
                    + " 失败!");
        }

        return date;

    }

    /**
     * @param source Date
     * @return String 日期时间字符串
     */
    public static String datetimeToString(Date source) {
        if (source == null) {
            return null;
        }
        String tmpString = null;
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(
                FORMAT_DATETIME_19);
        try {
            tmpString = simpleDateFormat.format(source);
        } catch (Exception e) {
        }
        return tmpString;
    }

    public static String datetimeToString14(Date source) {
        if (source == null) {
            return null;
        }
        String tmpString = null;
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(
                FORMAT_DATETIME_14);
        try {
            tmpString = simpleDateFormat.format(source);
        } catch (Exception e) {
        }
        return tmpString;
    }

    /**
     * @param source Date
     * @return String 日期字符串
     */
    public static String dateToString(Date source) {
        if (source == null) {
            return null;
        }
        String tmpString = null;
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(FORMAT_DATE_10);
        try {
            tmpString = simpleDateFormat.format(source);
        } catch (Exception e) {
        }
        return tmpString;
    }

    /**
     * @param source Date
     * @return String 日期字符串
     */
    public static String dateToString(Date source, String format) {
        if (source == null) {
            return null;
        }
        String tmpString = null;
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(format);
        try {
            tmpString = simpleDateFormat.format(source);
        } catch (Exception e) {
        }
        return tmpString;
    }

    /**
     * @param source Time
     * @return String 时间字符串
     */
    public static String timeToString(Date source) {
        if (source == null) {
            return null;
        }
        String tmpString = null;
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(FORMAT_TIME);
        try {

            tmpString = simpleDateFormat.format(source);
        } catch (Exception e) {
        }
        return tmpString;
    }

    /**
     * @param source Time
     * @return String 时间字符串
     */
    public static String timeMinuteToString(Date source) {
        if (source == null) {
            return null;
        }
        String tmpString = null;
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(
                FORMAT_MINUTE_TIME);
        try {
            tmpString = simpleDateFormat.format(source);
        } catch (Exception e) {
        }
        return tmpString;
    }

    /**
     * @param timeStr
     * @return
     */
    public static Date StringToTime(String timeStr) {

        Date date = null;
        String formatDateTmp = "";
        try {
            if (!StringUtil.isNotNullStr(timeStr, true)) {
                return date;
            }
            formatDateTmp = getTimeFormatString(timeStr);
            if (!StringUtil.isNotNullStr(formatDateTmp, true)) {
                return date;
            }
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat(
                    formatDateTmp);
            date = simpleDateFormat.parse(timeStr);
        } catch (Exception e) {
            log.error("时间：String: " + timeStr + " to Date: " + formatDateTmp
                    + " 失败!");
        }

        return date;
    }

    /**
     * 计算两个时间之间的月份长度 如 2004-1-23 到2004-4-05，月份差为4
     *
     * @param start
     * @param end
     * @return
     */
    public static int monthNumber(Date start, Date end) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(start);
        int startMonth = calendar.get(Calendar.MONTH);
        int startYear = calendar.get(Calendar.YEAR);
        calendar.setTime(end);
        int endMonth = calendar.get(Calendar.MONTH);
        int endYear = calendar.get(Calendar.YEAR);
        int number = 1;
        if (endYear > startYear) {
            number = (endMonth - startMonth + 1) + (endYear - startYear) * 12;
        } else if (endYear < startYear) {
            number = -((startMonth - endMonth + 1) + (startYear - endYear) * 12);
        } else {
            if (endMonth >= startMonth) {
                number = endMonth - startMonth + 1;
            } else {
                number = -(startMonth - endMonth + 1);
            }
        }
        return number;
    }

    public static Date addNumForYear(Date date, int amount) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        calendar.add(Calendar.YEAR, amount);
        return new Date(calendar.getTime().getTime());
    }

    public static Date addNumForMonth(Date date, int amount) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        calendar.add(Calendar.MONTH, amount);
        return new Date(calendar.getTime().getTime());
    }

    public static Date addNumForDay(Date date, int amount) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        calendar.add(Calendar.DAY_OF_MONTH, amount);
        return new Date(calendar.getTime().getTime());
    }

    // 将日期的月份加减
    public static Date addMonth(Date date, int amount) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        calendar.add(Calendar.MONTH, amount);
        calendar.set(Calendar.DATE,
                calendar.getActualMaximum(Calendar.DAY_OF_MONTH));// 最后一天);
        return new Date(calendar.getTime().getTime());
    }

    // 将日期的天数加减
    public static java.sql.Date addDay(Date date, int amount) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        calendar.add(Calendar.DAY_OF_MONTH, amount);
        return new java.sql.Date(calendar.getTime().getTime());
    }

    // 设置特定的月
    public static java.sql.Date setMonth(Date date, int month) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        calendar.set(Calendar.MONTH, month - 1);
        return new java.sql.Date(calendar.getTime().getTime());
    }

    // 设置特定的天(月中)
    public static java.sql.Date setDay(Date date, int day) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        calendar.set(Calendar.DAY_OF_MONTH, day);
        return new java.sql.Date(calendar.getTime().getTime());
    }

    // 是否是同一天
    public static boolean isSameDay(Date dateA, Date dateB) {
        SimpleDateFormat dateFormat = new SimpleDateFormat(FORMAT_DATE_10);
        return dateFormat.format(dateA).equals(dateFormat.format(dateB));
    }

    // 得到日期的年份
    public static int getYear(Date date) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        return calendar.get(Calendar.YEAR);
    }

    // 得到日期的月份
    public static int getMonth(Date date) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        return calendar.get(Calendar.MONTH) + 1;
    }

    // 是否是上个月的最后一天，最后一秒
    public static boolean isLastMonthLastDay(Date dateA) {
        Date date = new Date();
        int nowMonth = getMonth(date);
        int AMonth = getMonth(dateA);
        if (nowMonth > AMonth) {
            return true;
        } else {
            return false;
        }

    }

    // 得到日期的天(月中)
    public static int getDay(Date date) {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        return calendar.get(Calendar.DAY_OF_MONTH);
    }

    // 得到年，月，日的数组
    public static int[] getYMD(Date date) {
        int[] ymd = new int[3];
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        ymd[0] = calendar.get(Calendar.YEAR);
        ymd[1] = calendar.get(Calendar.MONTH) + 1;
        ymd[2] = calendar.get(Calendar.DAY_OF_MONTH);
        return ymd;
    }

    // 2004年12月21日 星期二 11:12:34
    public static String[] getFullChineseDate(Date date) {
        String[] result = new String[7];
        String[] back = new String[3];
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        result[0] = calendar.get(Calendar.YEAR) + "";
        result[1] = (calendar.get(Calendar.MONTH) + 1) + "";
        result[2] = calendar.get(Calendar.DAY_OF_MONTH) + "";
        result[3] = getChineseWeek(calendar.get(Calendar.DAY_OF_WEEK) - 1);
        result[4] = calendar.get(Calendar.HOUR_OF_DAY) + "";
        if (calendar.get(Calendar.MINUTE) >= 0
                && calendar.get(Calendar.MINUTE) < 9) {
            result[5] = "0" + calendar.get(Calendar.MINUTE) + "";
        } else {
            result[5] = calendar.get(Calendar.MINUTE) + "";
        }
        if (calendar.get(Calendar.SECOND) >= 0
                && calendar.get(Calendar.SECOND) <= 9) {
            result[6] = "0" + calendar.get(Calendar.SECOND) + "";
        } else {
            result[6] = calendar.get(Calendar.SECOND) + "";
        }
        back[0] = result[0] + "年" + result[1] + "月" + result[2] + "日";
        // back[0] = result[0] + "-" + result[1] + "-" + result[2];
        back[1] = result[3];
        back[2] = result[4] + ":" + result[5] + ":" + result[6];
        return back;
    }

    public static String getFullChineseDateToWeek(Date date) {
        String[] result = getFullChineseDate(date);
        return result[0] + " " + result[1];
    }

    public static String getChineseWeek(int number) {
        if (number < 0 || number > 6) {
            return null;
        }
        return chineseWeekNames[number];
    }

    private final static String[] chineseWeekNames = {"星期日", "星期一", "星期二",
            "星期三", "星期四", "星期五", "星期六"};

    public static int getMaxDay(int year, int month) {
        Calendar calendar = new GregorianCalendar();
        calendar.set(year, month - 1, 1);
        return calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
    }

    public static String getYear(String yearString) {
        boolean b = Pattern.matches("[0-9]{1,4}", yearString);
        String year = "0";
        if (b)
            year = yearString;
        return year;
    }

    /**
     * 验证日期
     */
    public static String getDate(String dateString) {
        int t[] = new int[3];
        String date = "";
        boolean b = Pattern.matches("[0-9]{1,4}-[0-9]{1,2}-[0-9]{1,2}",
                dateString);
        if (b) {
            String d[] = dateString.split("-");
            if (d.length != 3)
                date = "";
            for (int i = 0; i < 3; i++) {
                t[i] = Integer.parseInt(d[i]);
            }
            if (t[0] <= 0 || t[0] > 9999)
                date = "";
            if (t[1] < 1 || t[1] > 12)
                date = "";
            switch (t[1]) {
                case 1:
                case 3:
                case 5:
                case 7:
                case 8:
                case 10:
                case 12:
                    if (t[2] < 1 || t[2] > 31)
                        date = "";
                    else
                        date = String.valueOf(t[0]) + "-" + String.valueOf(t[1])
                                + "-" + String.valueOf(t[2]);
                    break;
                case 4:
                case 6:
                case 9:
                case 11:
                    if (t[2] < 1 || t[2] > 30)
                        date = "";
                    else
                        date = String.valueOf(t[0]) + "-" + String.valueOf(t[1])
                                + "-" + String.valueOf(t[2]);
                    break;
                case 2:
                    if (t[1] % 4 == 0 && (t[1] % 100 != 0 || t[1] % 400 == 0)) {
                        if (t[2] < 1 || t[2] > 29)
                            date = "";
                        else
                            date = String.valueOf(t[0]) + "-"
                                    + String.valueOf(t[1]) + "-"
                                    + String.valueOf(t[2]);
                    } else {
                        if (t[2] < 1 || t[2] > 28)
                            date = "";
                        else
                            date = String.valueOf(t[0]) + "-"
                                    + String.valueOf(t[1]) + "-"
                                    + String.valueOf(t[2]);
                    }
                    break;
            }
        }
        return date;
    }

    /**
     * 判断当前是星期几
     *
     * @param pTime
     * @return
     * @throws Throwable
     */
    public static int dayForWeek(String pTime) throws Throwable {
        String formatDateTmp = getFormatString(pTime);
        SimpleDateFormat format = new SimpleDateFormat(formatDateTmp);
        Calendar c = Calendar.getInstance();
        c.setTime(format.parse(pTime));
        int dayForWeek = 0;
        if (c.get(Calendar.DAY_OF_WEEK) == 1) {
            dayForWeek = 7;
        } else {
            dayForWeek = c.get(Calendar.DAY_OF_WEEK) - 1;
        }
        return dayForWeek;
    }

    public static String getWeekOfDate(String date) {
        String formatDateTmp = getFormatString(date);
        SimpleDateFormat format = new SimpleDateFormat(formatDateTmp);
        String[] weekDays = {"日", "一", "二", "三", "四", "五", "六"};
        // log.info("date:"+date);
        Calendar cal = Calendar.getInstance();
        try {
            // log.info("日期："+format.parse(date));
            cal.setTime(format.parse(date));
        } catch (ParseException e) {
            e.printStackTrace();
        }
        // log.info("Calendar:"+ cal.get(Calendar.DAY_OF_WEEK));
        int w = cal.get(Calendar.DAY_OF_WEEK) - 1;
        if (w < 0)
            w = 0;

        return weekDays[w];
    }

    /**
     * date1>date2 返回 true
     *
     * @param date1
     * @param date2
     * @return
     */
    public static boolean compareDate(Date date1, Date date2) {
        boolean flag = true;

        try {
            log.info("date1" + dateToString(date1) + " date2:"
                    + dateToString(date2));
            if (date1.getTime() > date2.getTime()) {
                log.info("DateUtil.compareDate :date1=" + date1.getTime()
                        + " date2=" + date2.getTime());
                return true;
            } else {
                return false;
            }
        } catch (Exception exception) {
            exception.printStackTrace();
        }

        return flag;
    }

    /**
     * 判断time是否在相应的时间区间内[]
     *
     * @param startTime 02:00:00
     * @param endTime   03:00:00
     * @param time      02:04:00
     * @return
     */
    public static boolean isBetweenTime(String startTime, String endTime,
                                        String time) {
        boolean flag = false;
        try {
            String nowDate = dateToString(new Date());
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-ddHH:mm:ss");
            Date dateTime = sdf.parse(nowDate + "" + time);
            Date startDateTime = sdf.parse(nowDate + "" + startTime);
            Date endDateTime = sdf.parse(nowDate + "" + endTime);
            log.info("startDateTime:" + startDateTime + " endDateTime:"
                    + endDateTime + " dateTime:" + dateTime);
            if ((dateTime.after(startDateTime) && dateTime.before(endDateTime))
                    || dateTime.getTime() == startDateTime.getTime()
                    || dateTime.getTime() == endDateTime.getTime()) {
                flag = true;
            }

        } catch (Exception exception) {
            exception.printStackTrace();
        }

        return flag;
    }

    /**
     * 两个时间相差的分钟数
     *
     * @param startDate
     * @param endDate
     * @return
     */
    public static long getIntervalByDate(Date startDate, Date endDate) {
        long interval = -1;
        if (startDate == null || endDate == null) {
            return interval;
        }
        long ss = (endDate.getTime() - startDate.getTime()) / (1000); // 共计秒数
        interval = (int) ss / 60; // 共计分钟数

        return interval;
    }

    /**
     * 设置时间，小时的加减
     *
     * @param date
     * @param hour +：增加，-:减少
     * @return
     */
    public static Date setTimeByHour(Date date, int hour) {
        // log.info("date:"+date+" hour:"+hour);
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.add(Calendar.HOUR, hour);
        return cal.getTime();
    }

    public static String formatString(Date date, String format) {
        if (date == null) {
            return "";
        }
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(format);
        try {
            return simpleDateFormat.format(date);
        } catch (Exception e) {
        }
        return "";
    }

    public static String formatString(Calendar date, String format) {
        if (date == null) {
            return "";
        }
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(format);
        try {
            return simpleDateFormat.format(date.getTime());
        } catch (Exception e) {
        }
        return "";
    }

    /**
     * 获取年龄
     *
     * @param birthday
     * @return
     */
    public static int getAge(String birthday) {

        Date now = new Date();
        Date bir = DateUtil.stringToDate(birthday);
        int age = DateUtil.getYear(now) - DateUtil.getYear(bir);

        if ((DateUtil.getMonth(now) - DateUtil.getMonth(bir)) > 0)
            age += 1;
        else if ((DateUtil.getMonth(now) - DateUtil.getMonth(bir)) == 0
                && (DateUtil.getDay(now) - DateUtil.getDay(bir)) >= 0)
            age += 1;

        return age;
    }

    /**
     * 某年某月天数
     *
     * @param year
     * @param month
     * @return int
     * @Title: getDaysOfMonth
     */
    public static int getDaysOfMonth(int year, int month) {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.YEAR, year);
        cal.set(Calendar.MONTH, month);
        return cal.getActualMaximum(Calendar.DATE);
    }

    public static Date getLastTimeOfMonth(int year, int month) {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.YEAR, year);
        cal.set(Calendar.MONTH, month + 1);
        cal.set(Calendar.DAY_OF_MONTH, 0);
        cal.set(Calendar.HOUR_OF_DAY, 23);
        cal.set(Calendar.MINUTE, 59);
        cal.set(Calendar.SECOND, 59);
        return cal.getTime();
    }

    public static Date getFristTimeOfMonth(int year, int month) {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.YEAR, year);
        cal.set(Calendar.MONTH, month);
        cal.set(Calendar.DAY_OF_MONTH, 1);
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        return cal.getTime();
    }

    public static Date getLastTimeOfMonth(Date date) {
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.add(Calendar.MONTH, 1);
        cal.set(Calendar.DAY_OF_MONTH, 0);
        cal.set(Calendar.HOUR_OF_DAY, 23);
        cal.set(Calendar.MINUTE, 59);
        cal.set(Calendar.SECOND, 59);
        return cal.getTime();
    }

    public static Date getFristTimeOfMonth(Date date) {
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.set(Calendar.DAY_OF_MONTH, 1);
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        return cal.getTime();
    }

    public static Date getStartTimeOfDay() {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        return cal.getTime();
    }

    public static Date getStartTimeOfDayAgo(int numOfDay) {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        cal.add(Calendar.DAY_OF_MONTH, -numOfDay);
        return cal.getTime();
    }
    
    public static Date getStartTimeOfPreDay() {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        cal.add(Calendar.DAY_OF_MONTH, -1);
        return cal.getTime();
    }

    public static Date getStartTimeOfMonthAgo(int numMonth) {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        cal.set(Calendar.DAY_OF_MONTH, 1);
        cal.add(Calendar.MONTH, -numMonth);
        return cal.getTime();
    }

    public static Date getEndTimeOfMonthAgo(){
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 23);
        cal.set(Calendar.MINUTE, 59);
        cal.set(Calendar.SECOND, 59);
        cal.set(Calendar.MILLISECOND, 59);
        cal.set(Calendar.DAY_OF_MONTH, cal.getActualMaximum(Calendar.DAY_OF_MONTH));
        return cal.getTime();
    }

    public static Date getStartTimeOfPreMonth() {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        cal.set(Calendar.DAY_OF_MONTH, 1);
        cal.add(Calendar.MONTH, -1);
        return cal.getTime();
    }
    public static Date getStartTimeOfYear() {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        cal.set(Calendar.DAY_OF_MONTH, 1);
//        cal.add(Calendar.MONTH, -1);
        cal.set(Calendar.MONTH, 1);
        return cal.getTime();
    }

    public static Date getEndTimeOfYear() {
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.MONTH,calendar.getActualMaximum(Calendar.MONTH));
        calendar.set(Calendar.DAY_OF_MONTH,calendar.getActualMaximum(Calendar.DAY_OF_MONTH));
        calendar.set(Calendar.HOUR_OF_DAY, 23);
        calendar.set(Calendar.MINUTE, 59);
        calendar.set(Calendar.SECOND, 59);
        calendar.set(Calendar.MILLISECOND, 59);
        return calendar.getTime();
    }

    public static Date getStartTimeOfYearAgo(int year) {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        cal.set(Calendar.DAY_OF_MONTH, 1);
//        cal.add(Calendar.MONTH, -numMonth);
        cal.set(Calendar.MONTH, 1);
        cal.add(Calendar.YEAR, -year);
        return cal.getTime();
    }

    public static Date getDayOfLastMonth() {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
//        cal.set(Calendar.DAY_OF_MONTH, 1);
        cal.add(Calendar.MONTH, -1);
        return cal.getTime();
    }


    public static Date getStartTimeOfNextDay() {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        cal.add(Calendar.DAY_OF_MONTH, 1);
        return cal.getTime();
    }

    public static Date getEndTimeOfDay() {
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 23);
        cal.set(Calendar.MINUTE, 59);
        cal.set(Calendar.SECOND, 59);
        cal.set(Calendar.MILLISECOND, 0);
        return cal.getTime();
    }

    public static Date getStartTimeOfDay(Date date) {
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        return cal.getTime();
    }

    public static Date getEndTimeOfDay(Date date) {
        Calendar cal = Calendar.getInstance();
        if (date == null) {
            date = new Date();
        }
        cal.setTime(date);
        cal.set(Calendar.HOUR_OF_DAY, 23);
        cal.set(Calendar.MINUTE, 59);
        cal.set(Calendar.SECOND, 59);
        cal.set(Calendar.MILLISECOND, 0);
        return cal.getTime();
    }

    public static Date strToDate(String str, String dateFormat) {
        SimpleDateFormat format = new SimpleDateFormat(dateFormat);
        Date date = null;
        try {
            date = format.parse(str);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return date;
    }

    public static String dateToStr(Date date, String dateFormat) {
        SimpleDateFormat format = new SimpleDateFormat(dateFormat);
        String str = format.format(date);
        return str;
    }

    public static int calcAge(Date birthDate) {
        Date nowDate = new Date();
        Calendar flightCal = Calendar.getInstance();
        flightCal.setTime(nowDate);
        Calendar birthCal = Calendar.getInstance();
        birthCal.setTime(birthDate);

        int y = flightCal.get(Calendar.YEAR) - birthCal.get(Calendar.YEAR);
        int m = flightCal.get(Calendar.MONTH) - birthCal.get(Calendar.MONTH);
        int d = flightCal.get(Calendar.DATE) - birthCal.get(Calendar.DATE);
        if (y < 0) {
            return 0;
            // throw new RuntimeException("您老还没出生");
        }
        if (m < 0) {
            y--;
        }
        if (m >= 0 && d < 0) {
            y--;
        }
        return y;
    }

    // 获取日期月日 例如 2016-01-05 返回 105
    public static int calcMonthDay(Date birthDate) {
        Calendar birthCal = Calendar.getInstance();
        birthCal.setTime(birthDate);
        int m = birthCal.get(Calendar.MONTH);
        int d = birthCal.get(Calendar.DATE);
        StringBuilder monthDay = new StringBuilder(String.valueOf(m + 1));
        if (d < 10)
            monthDay.append("0");
        monthDay.append(String.valueOf(d));
        return Integer.valueOf(monthDay.toString());
    }

    /**
     * 计算两个日期之间相差的天数
     *
     * @param smdate 较小的时间
     * @param bdate  较大的时间
     * @return 相差天数
     * @throws ParseException
     */
    public static int daysBetween(Date smdate, Date bdate) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        try {
            smdate = sdf.parse(sdf.format(smdate));
            bdate = sdf.parse(sdf.format(bdate));
        } catch (ParseException e) {
            e.printStackTrace();
//			log.error(e.getMessage());
        }
        Calendar cal = Calendar.getInstance();
        cal.setTime(smdate);
        long time1 = cal.getTimeInMillis();
        cal.setTime(bdate);
        long time2 = cal.getTimeInMillis();
        long between_days = (time2 - time1) / (1000 * 3600 * 24);

        return Integer.parseInt(String.valueOf(between_days));
    }

    /**
     * 获取时间段内平时和双休的天数 包含开始日期和结束日期
     *
     * @param begin 起始日期
     * @param end   结束日期
     * @return
     */
    public static int[] getWeekEndCountBetweenDate(Date begin, Date end) {

        Calendar beginTemp = Calendar.getInstance();
        beginTemp.setTime(begin);
        beginTemp.set(Calendar.HOUR_OF_DAY, 0);
        beginTemp.set(Calendar.MINUTE, 0);
        beginTemp.set(Calendar.SECOND, 0);
        beginTemp.set(Calendar.MILLISECOND, 0);

        Calendar endTemp = Calendar.getInstance();
        endTemp.setTime(end);
        endTemp.set(Calendar.HOUR_OF_DAY, 0);
        endTemp.set(Calendar.MINUTE, 0);
        endTemp.set(Calendar.SECOND, 0);
        endTemp.set(Calendar.MILLISECOND, 0);
        endTemp.add(Calendar.DAY_OF_MONTH, 1);

        int weekDay = 0;
        int commons = 0;
        int weekend = 0;
        while (beginTemp.before(endTemp)) {

            weekDay = beginTemp.get(Calendar.DAY_OF_WEEK);
            if (weekDay == Calendar.SATURDAY || weekDay == Calendar.SUNDAY) {
                weekend++;
            } else {
                commons++;
            }
            beginTemp.add(Calendar.DAY_OF_MONTH, 1);
        }
        return new int[]{commons, weekend};
    }

    /**
     * 判断是否是周末
     *
     * @param date
     * @return
     */
    public static boolean isWeekEnd(Date date) {

        Calendar temp = Calendar.getInstance();
        temp.setTime(date);

        int weekDay = temp.get(Calendar.DAY_OF_WEEK);
        if (weekDay == Calendar.SATURDAY || weekDay == Calendar.SUNDAY)
            return true;

        return false;
    }

    // 获得星座
    private final static int[] dayArr = new int[]{20, 19, 21, 20, 21, 22, 23,
            23, 23, 24, 23, 22};
    private final static String[] constellationArr = new String[]{"摩羯座",
            "水瓶座", "双鱼座", "白羊座", "金牛座", "双子座", "巨蟹座", "狮子座", "处女座", "天秤座",
            "天蝎座", "射手座", "摩羯座"};

    public static String getConstellation(Date date) {
        int month = DateUtil.getMonth(date);
        int day = DateUtil.getDay(date);
        return day < dayArr[month - 1] ? constellationArr[month - 1]
                : constellationArr[month];
    }

    // 返回连续月数
    @SuppressWarnings({"unchecked", "rawtypes"})
    public static int continuousMonth(List<String> monthList) { // String格式 201701
        if (monthList.isEmpty())
            return 0;
        Collections.sort(monthList, new Comparator() {
            public int compare(Object o1, Object o2) {
                return new Integer((String) o1)
                        .compareTo(new Integer((String) o2));
            }
        });
        int res = 0;
        int temp = 1;
        String nextMonth = null;
        for (String monthStr : monthList) {
            if (monthStr.equals(nextMonth)) {
                temp++;
            } else {
                if (temp > res)
                    res = temp;
                temp = 1;
            }
            nextMonth = dateToStr(
                    addNumForMonth(stringToDate(monthStr + "01"), 1),
                    FORMAT_DATE_8).substring(0, 6);
        }
        if (temp > res)
            res = temp;
        return res;
    }

    /**
     * 获取开始时间和介绍时间之间的日期，包含开始时间和结束时间
     *
     * @param start 开始时间
     * @param end   结束时间
     * @return
     */
    public static List<String> getBetweenDates(String start, String end) throws ParseException {
        List<String> result = new ArrayList<String>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Calendar tempStart = Calendar.getInstance();
        tempStart.setTime(sdf.parse(start));
        Calendar tempEnd = Calendar.getInstance();
        tempEnd.setTime(sdf.parse(end));
        while (tempStart.before(tempEnd)) {
            result.add(sdf.format(tempStart.getTime()));
            tempStart.add(Calendar.DAY_OF_YEAR, 1);
        }
        result.add(sdf.format(tempEnd.getTime()));
        return result;
    }

    /**
     * 获取开始时间和介绍时间之间的日期，包含结束时间
     *
     * @param start 开始时间
     * @param end   结束时间
     * @return
     */
    public static List<String> getBetweenDate(Date start, Date end) {
        end = addNumForDay(end, 1);
        List<String> result = new ArrayList<String>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Calendar tempStart = Calendar.getInstance();
        tempStart.setTime(start);
        Calendar tempEnd = Calendar.getInstance();
        tempEnd.setTime(end);
        while (tempStart.before(tempEnd)) {
            result.add(sdf.format(tempStart.getTime()));
            tempStart.add(Calendar.DAY_OF_YEAR, 1);
        }
        return result;
    }

    /**
     * 获取开始时间和介绍时间之间的日期，不包含结束时间
     *
     * @param start 开始时间
     * @param end   结束时间
     * @return
     */
    public static List<String> getBetweenDates(Date start, Date end) {
        List<String> result = new ArrayList<String>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Calendar tempStart = Calendar.getInstance();
        tempStart.setTime(start);
        Calendar tempEnd = Calendar.getInstance();
        tempEnd.setTime(end);
        while (tempStart.before(tempEnd)) {
            result.add(sdf.format(tempStart.getTime()));
            tempStart.add(Calendar.DAY_OF_YEAR, 1);
        }
        return result;
    }

    /**
     * 获取两个时间的时间间隔数：分钟或小时或天
     *
     * @param begin
     * @param end
     * @return
     */
    public static String getBetweenTime(long begin, long end) {
        long between = end - begin;
        if (between > ONE_DAY) {
            return between / ONE_DAY + "天";
        } else if (between > ONE_HOUR) {
            return between / ONE_HOUR + "小时";
        } else {
            return between / ONE_MINUTE + "分";
        }
    }

    /**
     * 获取月-日
     *
     * @param date
     * @return
     */
    public static String getMonthDay(Date date) {
        SimpleDateFormat sdf = new SimpleDateFormat(MONTH_DAY);
        return sdf.format(date);
    }

    /**
     * 获取年-月
     *
     * @param date
     * @return
     */
    public static String getYearMonth(Date date) {
        SimpleDateFormat sdf = new SimpleDateFormat(YEAR_MONTH);
        return sdf.format(date);
    }

    /**
     * 设置时间的时分秒
     *
     * @param date
     * @param HH
     * @param mm
     * @param ss
     * @return
     */
    public static Date setTimeHHmmss(Date date, int HH, int mm, int ss) {
        Calendar c = Calendar.getInstance();
        c.setTime(date);
        c.set(Calendar.HOUR_OF_DAY, HH);
        c.set(Calendar.MINUTE, mm);
        c.set(Calendar.SECOND, ss);
        return c.getTime();
    }

    /**
     * 设置时间的时分秒
     *
     * @param date
     * @param HHmmss
     * @return
     */
    public static Date setTimeHHmmss(Date date, String HHmmss) {
        if (HHmmss == null) {
            return date;
        }
        String[] time = HHmmss.split(":");
        Calendar c = Calendar.getInstance();
        c.setTime(date);
        if (time.length > 0) {
            c.set(Calendar.HOUR_OF_DAY, Integer.valueOf(time[0]));
        }
        if (time.length > 1) {
            c.set(Calendar.MINUTE, Integer.valueOf(time[1]));
        }
        if (time.length > 2) {
            c.set(Calendar.SECOND, Integer.valueOf(time[2]));
        }
        return c.getTime();
    }

    public static List<String> getBetweenYM(String beginYM, String endYM) {
        List<String> ymList = new ArrayList<String>();
        try {

            Date d1 = new SimpleDateFormat("yyyy-MM").parse(beginYM);//定义起始日期

            Date d2 = new SimpleDateFormat("yyyy-MM").parse(endYM);//定义结束日期

            Calendar dd = Calendar.getInstance();//定义日期实例
            Calendar dd2 = Calendar.getInstance();//定义日期实例
            dd.setTime(d1);//设置日期起始时间
            dd2.setTime(d2);
            if (dd.getTime().equals(dd2.getTime())) {
                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM");
                String str = sdf.format(dd.getTime());
                ymList.add(str);
            } else {
                while (dd.getTime().before(d2)) {//判断是否到结束日期
                    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM");
                    String str = sdf.format(dd.getTime());
                    ymList.add(str);
                    dd.add(Calendar.MONTH, 1);//进行当前日期月份加1

                }
            }


        } catch (Exception e) {
            e.printStackTrace();
            log.info("时间转换错误,beginYM:" + beginYM + ",endYM:" + endYM);
        }
        return ymList;
    }

    /**
     * 2017-01-01 11:11:11 转为 01月01日 11:11
     *
     * @param dateTime
     * @return
     */
    public static String getMonthDayHHmm(String dateTime) {
        dateTime = dateTime.substring(5, dateTime.length());
        dateTime = dateTime.substring(0, 11);
        dateTime = dateTime.replace("-", "月").replace(" ", "日");
        return dateTime;
    }

    /*获取星期几*/
    public static int getWeek() {
        Calendar cal = Calendar.getInstance();
        int week = cal.get(Calendar.DAY_OF_WEEK);
        switch (week) {
            case 1:
                return 7;
            case 2:
                return 1;
            case 3:
                return 2;
            case 4:
                return 3;
            case 5:
                return 4;
            case 6:
                return 5;
            case 7:
                return 6;
            default:
                return 0;
        }
    }

    public static Date getBeginDayOfMonth() {
        Calendar cal = Calendar.getInstance();
        cal.set(getNowYear().intValue(), getNowMonth() - 1, 1);
        cal.set(11, 0);
        cal.set(12, 0);
        cal.set(13, 0);
        cal.set(14, 0);
        return cal.getTime();
    }

    public static Date getEndDayOfMonth() {
        Calendar cal = Calendar.getInstance();
        cal.set(getNowYear().intValue(), getNowMonth() - 1, 1);
        int day = cal.getActualMaximum(5);
        cal.set(getNowYear().intValue(), getNowMonth() - 1, day);
        cal.set(11, 23);
        cal.set(12, 59);
        cal.set(13, 59);
        cal.set(14, 0);
        return cal.getTime();
    }
    public static Integer getNowYear() {
        Date date = new Date();
        GregorianCalendar gc = (GregorianCalendar)Calendar.getInstance();
        gc.setTime(date);
        return Integer.valueOf(gc.get(1));
    }
    public static int getNowMonth() {
        Date date = new Date();
        GregorianCalendar gc = (GregorianCalendar)Calendar.getInstance();
        gc.setTime(date);
        return gc.get(2) + 1;
    }

    public static String timestampToString(Timestamp source) {
        if (source == null) {
            return null;
        }
        String tmpString = null;
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(
                FORMAT_DATETIME_19);
        try {
            tmpString = simpleDateFormat.format(source);
        } catch (Exception e) {
        }
        return tmpString;
    }

    public static Date getDate(){
        Calendar calendar=Calendar.getInstance();
        calendar.set(Calendar.HOUR_OF_DAY,0);
        calendar.set(Calendar.MINUTE,0);
        calendar.set(Calendar.SECOND,0);
        return calendar.getTime();
    }

    public static void main(String[] args) {
       /* Date date = setTimeHHmmss(new Date(), "08:00:00");
        System.out.println(datetimeToString(date));
        System.out.println(getMonthDayHHmm("2017-01-01 11:11:11"));

        boolean flag = compareDate(stringToDate("2017-09-03 20:07:44"), stringToDate("2017-09-03 20:08:34"));
        System.out.println("flag:" + flag);*/
//       System.out.println(DateUtil.getStartTimeOfDay().getTime());
//       System.out.println((new Date()).getTime());

        /*Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 23);
        cal.set(Calendar.MINUTE, 59);
        cal.set(Calendar.SECOND, 59);
        cal.set(Calendar.MILLISECOND, 0);*/

//        Calendar calendar = Calendar.getInstance();
//        //设置为入参时间
////        calendar.setTimeInMillis(date);
//        //取得当天的起始时间
//        calendar.set(Calendar.HOUR_OF_DAY,0);
//        calendar.set(Calendar.MINUTE, 0);
//        calendar.set(Calendar.SECOND, 0);
//        calendar.set(Calendar.MILLISECOND, 0);
//
//        //取得当天的结束时间
//        calendar.add(Calendar.DATE,1);
//        calendar.add(Calendar.MILLISECOND,-1);
//
//        System.out.println(calendar.getTime());

//        System.out.println(getEndTimeOfYear());
//
//        Calendar cal = Calendar.getInstance();
//        cal.set(Calendar.HOUR_OF_DAY, 23);
//        cal.set(Calendar.MINUTE, 59);
//        cal.set(Calendar.SECOND, 59);
//        cal.set(Calendar.MILLISECOND, 59);
//        cal.set(Calendar.DAY_OF_MONTH, cal.getActualMaximum(Calendar.DAY_OF_MONTH));
//
//        System.out.println(cal.getTime());
        /*System.out.println(getDay(new Date()));
        Long l=0l;
        int i=0;
        System.out.println(l==i);*/
//        System.out.println(timestampToString(new Timestamp(System.currentTimeMillis())));
        System.out.println(timestampToString(null));

    }
}
