package com.gic.spark.util;

import com.alibaba.fastjson.JSON;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

/**
 * @description:
 * @author: wangxk
 * @date: 2019/10/18
 */
public class EntityUtil {
    private static Logger logger = LogManager.getLogger(EntityUtil.class);

    public EntityUtil() {
    }

    public static <T> T changeEntityNew(Class<T> target, Object baseTO) {
        try {
            T obj = target.newInstance();
            if(baseTO == null) {
                return null;
            } else {
                BeanUtils.copyProperties(baseTO, obj);
                return obj;
            }
        } catch (Exception var3) {
            return changeEntity(target, baseTO);
        }
    }

    public static <T> List<T> changeEntityListNew(Class<T> target, List<?> list) {
        if(list != null && list.size() != 0) {
            List<T> resultList = new ArrayList();
            Iterator var3 = list.iterator();

            while(var3.hasNext()) {
                Object obj = var3.next();
                resultList.add(changeEntityNew(target, obj));
            }

            return resultList;
        } else {
            return null;
        }
    }

    public static <T> T changeEntity(Class<T> target, Object baseTO) {
        T obj = null;
        if(baseTO == null) {
            return null;
        } else {
            try {
                obj = target.newInstance();
                List<Method> targetmethods = Arrays.asList(target.getDeclaredMethods());
                List<String> methodnames = new ArrayList();
                Iterator var5 = targetmethods.iterator();

                while(var5.hasNext()) {
                    Method method = (Method)var5.next();
                    methodnames.add(method.getName());
                }

                Method[] methods = baseTO.getClass().getDeclaredMethods();

                for(int i = 0; i < methods.length; ++i) {
                    Method method = methods[i];
                    if(method.getName().startsWith("get")) {
                        String _tar = "set" + method.getName().substring(method.getName().indexOf("get") + 3);
                        if(methodnames.contains(_tar)) {
                            Method tarMethod = (Method)targetmethods.get(methodnames.indexOf(_tar));
                            if(tarMethod.getParameterTypes()[0].equals(method.getReturnType())) {
                                tarMethod.setAccessible(true);
                                tarMethod.invoke(obj, new Object[]{method.invoke(baseTO, new Object[0])});
                            }
                        }
                    }
                }
            } catch (Exception var10) {
                logger.error("解析错误", var10);
            }

            return obj;
        }
    }

    public static <T> T changeEntityByJSON(Class<T> target, Object baseTO) {
        T obj = JSON.parseObject(JSON.toJSONString(baseTO), target);
        return obj;
    }

    public static <T> List<T> changeEntityListByJSON(Class<T> target, Object baseTO) {
        List<T> obj = JSON.parseArray(JSON.toJSONString(baseTO), target);
        return obj;
    }
}
