package com.gic.spark.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by paste on 2019/4/8 17:04
 * <p>
 * TODO: class description
 */
public class IndexRequestUtil {

    public static List<String> getStoreId(Integer enterpriseId, String widgetId, boolean isProd) {
        String url = isProd?"https://four.gicdev.com/gic-store-web/list-widget-store-info?enterpriseId="+enterpriseId+"&storeWidgetId="+widgetId
                           :"https://ideal.demogic.com/gic-store-web/list-widget-store-info?enterpriseId="+enterpriseId+"&storeWidgetId="+widgetId;

        HttpResponse response = HttpClient.getHttpResponseByGet(url);
        JSONObject jsonObject = JSONObject.parseObject(HttpClient.getResponseString(response));
        List<String> result = new ArrayList();
        try {
            JSONArray jsonArray = jsonObject.getJSONObject("result").getJSONArray("result");
            for (Object obj : jsonArray) {
                result.add((String)obj);
            }
        } catch (Exception e) {
            DingtalkMessageUtil.sendAlertMessage("widgetId: " + widgetId + " enterpriseId: " + enterpriseId +  " parsing store error " );
        }
        return result;
    }


    public static List<String> getGoodsInfoById(String enterpriseId ,String selectorId, boolean isProd) {

        String url = "http://gicdev.demogic.com/api-plug/get-store-goods-sku-filter?enterpriseId="+enterpriseId+"&id=" + selectorId;
        if (isProd) {
            url = "http://demogic.com/api-plug/get-store-goods-sku-filter?requestProject=goods&enterpriseId="+enterpriseId+"&id=" + selectorId;
        }

        try {
            HttpResponse response = HttpClient.getHttpResponseByGet(url);

            JSONObject jsonObject = JSONObject.parseObject(HttpClient.getResponseString(response));
            JSONArray filterConditions = jsonObject.getJSONObject("result").getJSONArray("filterCondition");

            System.out.println("filterConditions==>"+filterConditions.toJSONString());

            JSONObject resultSku=getSkuCode(enterpriseId , filterConditions, isProd ,1);
            int total=resultSku.getJSONObject("result").getIntValue("total");
            JSONArray resultArray = resultSku.getJSONObject("result").getJSONArray("result");
            List<String> skuList = new ArrayList(total);
            for (Object object : resultArray) {
                JSONObject goodsInfo = (JSONObject) object;
                skuList.add(goodsInfo.getString("skuCode"));
            }

            int totalPages= (total-1)/1000+1;
            if(totalPages>1){
                for(int i=2;i<=totalPages;i++){
                    JSONObject rlt=getSkuCode(enterpriseId , filterConditions, isProd ,i);
                    if(null!=rlt){
                        JSONObject rltJSONO= rlt.getJSONObject("result");
                        if(null!=rltJSONO){
                            JSONArray rltArray = rltJSONO.getJSONArray("result");
                            for (Object object : rltArray) {
                                JSONObject goodsInfo = (JSONObject) object;
                                skuList.add(goodsInfo.getString("skuCode"));
                            }
                        }
                    }
                }
            }
            return skuList;
        }catch (Exception e){
            e.printStackTrace();
            DingtalkMessageUtil.sendAlertMessage("selectorId: " + selectorId + " parsing result error " );
        }
        return null;
    }
    private static JSONObject getSkuCode( String enterpriseId ,JSONArray filterConditions, boolean isProd,int currentPage) throws IOException {
        String skuUrl = "http://gicdev.demogic.com/api-plug/store-goods-sku-filter?enterpriseId=" + enterpriseId;
        if (isProd) {
            skuUrl = "http://demogic.com/api-plug/store-goods-sku-filter?enterpriseId=" + enterpriseId;
        }
        HttpPost httpPost = new HttpPost(skuUrl);
        httpPost.addHeader("Content-Type", "application/json;charset=UTF-8");
        JSONObject requestObject = new JSONObject();
        requestObject.put("currentPage", currentPage);
        requestObject.put("pageSize", Integer.MAX_VALUE);
        requestObject.put("queryList", filterConditions);
        requestObject.put("source", 1);
        StringEntity stringEntity = new StringEntity(requestObject.toString(), "UTF-8");
        stringEntity.setContentEncoding("UTF-8");
        httpPost.setEntity(stringEntity);
        HttpResponse response = HttpClient.getHttpClient().execute(httpPost);
        JSONObject result = JSONObject.parseObject(HttpClient.getResponseString(response));
        return result;
    }
}
