package org.elasticsearch.spark

import org.apache.commons.logging.LogFactory
import org.apache.spark.Partitioner
import org.elasticsearch.hadoop.cfg.PropertiesSettings
import org.elasticsearch.hadoop.rest.RestRepository

class ESShardPartitioner(settings: String) extends Partitioner {
  protected val log = LogFactory.getLog(this.getClass())

  protected var _numPartitions = -1

  override def numPartitions: Int = {
    val newSettings = new PropertiesSettings().load(settings)
    val repository = new RestRepository(newSettings)
    val targetShards = repository.getWriteTargetPrimaryShards(newSettings.getNodesClientOnly())
    repository.close()
    _numPartitions = targetShards.size() * 25
    _numPartitions
  }

  override def getPartition(key: Any): Int = {
    val shardId = ShardAlg.shard(key.toString(), _numPartitions)
    shardId
  }
}
